CorCovSymbJenn <- function(data.sym){
  data=data.sym$data
  p = (ncol(data))/2	      # nombre de variables
  m = nrow(data)		      # nombre d'observations
  namesobj <- data.sym$sym.obj.names
  namesvar <- data.sym$sym.var.names
  # MATRICE DES CENTRES, YBARU, ET MOYENNE EMPIRIQUE TOTALE, ybar 
  ybaru <- matrix(0, m, p)	      
  for (u in 1:m) {
    for (j in 1:p){ 
      ybaru[u,j] <- (data[u,2*j-1] + data[u,2*j])/2
    }
  }
  ybar = c(rep(0,p))	
  for (j in 1:p){
    ybar[j] = sum(ybaru[,j])/m
  }
  # SIGNE DE LA MATRICE DES COVARIANCES/CORRELATIONS
  Gu = matrix(-1, m, p)
  for (j in 1:p){
    for (u in 1:m){ 
      if (ybaru[u,j] > ybar[j])  
        Gu[u,j] <- 1
    }
  }
  # TERMES POUR LA COVARIANCE
  Qu <- matrix(0, m, p)
  for (j in 1:p){
    for (u in 1:m){ 
      Qu[u,j] = (data[u,2*j-1] - ybar[j])^2 + (data[u,2*j-1] - ybar[j])*(data[u,2*j] - ybar[j]) + (data[u,2*j] - ybar[j])^2
    }
  }
  # MATRICE DE COVARIANCE
  Cov <- matrix(0, p, p)
  for (j in 1:p){	
    for (i in 1:j){
      Cov[i,j] = sum((Gu[,i]*Gu[,j]*sqrt(Qu[,i]*Qu[,j])))/(3*m)
      Cov[j,i] = Cov[i,j]
    }
  } 
  rownames(Cov) <- namesvar
  colnames(Cov) <- namesvar
  # MATRICE DE CORRELATION
  Corr <- matrix(0, p, p)
  for (j in 1:p){	
    for (i in 1:j){
      Corr[i,j] = Cov[i,j]/(sqrt((Cov[i,i])*(Cov[j,j])))
      Corr[j,i] = Corr[i,j]
    }
  }
  rownames(Corr)=namesvar
  colnames(Corr)=namesvar
  # RESULTS
  list(cov=Cov, corr=Corr)
}
