CrossVal_RegSymbvc <- function(data.sym.Y, data.sym.X, nbrepet)
{ 
  #data.sym.Y=dataY.sym
  #data.sym.X=dataXred.sym	
  #nbrepet=10	
  # PRÉ-REQUIS
  library(RSDA) 
  library(iRegression)
  N  <- data.sym.Y$N
  Nc <- round(2*N/ 3)
  Nv <- N - Nc
  # FICHIERS DE STOCKAGE DES RMSE OBTENUES
  RMSEc.cm     <- matrix(0, nrow=nbrepet, 2)
  RMSEv.cm     <- matrix(0, nrow=nbrepet, 2)
  RMSEc.crm    <- matrix(0, nrow=nbrepet, 2) 
  RMSEv.crm    <- matrix(0, nrow=nbrepet, 2)
  RMSEc.regbiv <- matrix(0, nrow=nbrepet, 2) 
  RMSEv.regbiv <- matrix(0, nrow=nbrepet, 2)  
  RMSEc.reg    <- matrix(0, nrow=nbrepet, 2)
  RMSEv.reg    <- matrix(0, nrow=nbrepet, 2)   
  RMSEname <- c("Borne inf.", "Borne sup.")
  colnames(RMSEc.cm)     <- RMSEname
  colnames(RMSEv.cm)     <- RMSEname
  colnames(RMSEc.crm)    <- RMSEname
  colnames(RMSEv.crm)    <- RMSEname
  colnames(RMSEc.regbiv) <- RMSEname
  colnames(RMSEv.regbiv) <- RMSEname  
  colnames(RMSEc.reg)    <- RMSEname
  colnames(RMSEv.reg)    <- RMSEname
  # FICHIERS DE STOCKAGE DES COEFFICIENTS 'R' OBTENUS
  Rc.cm     <- matrix(0, nrow=nbrepet, 1)
  Rv.cm     <- matrix(0, nrow=nbrepet, 1)
  Rc.crm    <- matrix(0, nrow=nbrepet, 1) 
  Rv.crm    <- matrix(0, nrow=nbrepet, 1)
  Rc.regbiv <- matrix(0, nrow=nbrepet, 1)
  Rv.regbiv <- matrix(0, nrow=nbrepet, 1)   
  Rc.reg    <- matrix(0, nrow=nbrepet, 1)
  Rv.reg    <- matrix(0, nrow=nbrepet, 1)   
  Rname <- c("Cor.Ypred-Y")
  colnames(Rc.cm)     <- Rname
  colnames(Rv.cm)     <- Rname
  colnames(Rc.crm)    <- Rname
  colnames(Rv.crm)    <- Rname
  colnames(Rc.regbiv) <- Rname
  colnames(Rv.regbiv) <- Rname  
  colnames(Rc.reg)    <- Rname
  colnames(Rv.reg)    <- Rname  
  
  for(i in 1 : nbrepet) {
    datasym <- cbind(data.sym.Y$meta, data.sym.X$meta)    
    write.table(datasym, "datasym.csv", dec=".", sep=";", row.names=FALSE)
    data.sym <- read.sym.table("datasym.csv", header=TRUE, sep=";",dec=".",row.names=NULL)
    #TIRAGE AU SORT DES LIGNES
    s  <- sample(x=N, size=Nc)
    # CREATION DES DONNEES DE CALIBRATION (2/3)
    write.table(data.sym.Y$meta[s, ], "dataYc", dec=".", sep=";", row.names=FALSE)
    dataC.Y.sym <- read.sym.table("dataYc", header=TRUE, sep=";",dec=".",row.names=NULL)
    
    write.table(data.sym.X$meta[s, ], "dataXc", dec=".", sep=";", row.names=FALSE)
    dataC.X.sym <- read.sym.table("dataXc", header=TRUE, sep=";",dec=".",row.names=NULL)  
    write.table(data.sym$meta[s, ], "dataC.csv", dec=".", sep=";", row.names=FALSE)
    dataC.sym <-read.sym.table("dataC.csv", header=TRUE, sep=";",dec=".",row.names=NULL)  
    #CREATION DES DONNEES DE VALIDATION (1/3)
    write.table(data.sym.Y$meta[-s, ], "dataYv", dec=".", sep=";", row.names=FALSE)
    dataV.Y.sym <- read.sym.table("dataYv", header=TRUE, sep=";",dec=".",row.names=NULL)
    write.table(data.sym.X$meta[-s, ], "dataXv", dec=".", sep=";", row.names=FALSE)
    dataV.X.sym <- read.sym.table("dataXv", header=TRUE, sep=";",dec=".",row.names=NULL)
    write.table(data.sym$meta[-s, ], "dataV.csv", dec=".", sep=";", row.names=FALSE)
    dataV.sym <-read.sym.table("dataV.csv", header=TRUE, sep=";",dec=".",row.names=NULL)   
    # METHODE 1 : METHODE DES CENTRES (CALIBRATION --> RMSEC)
    cal.regcm     <- sym.lm(Condemn  ~ ., dataC.sym, method ="cm")    # sym.var(data.sym, 4)    
    cal.pred.cm   <- predictsym.lm(cal.regcm, dataC.sym, method="cm")
    RMSEc.m.cm    <- RMSE.L(sym.var(dataC.sym, 1), cal.pred.cm$Fitted)
    RMSEc.M.cm    <- RMSE.U(sym.var(dataC.sym, 1), cal.pred.cm$Fitted) 
    RMSEc.cm[i, ] <- cbind(RMSEc.m.cm, RMSEc.M.cm)
    # Rc.cm
    colint             <- matrix("$I", dataC.sym$N, 1) 
    predc.cm           <-cbind(colint,cal.pred.cm$Fitted)
    colnames(predc.cm) <- c("$I", "Pred.min", "Pred.max")
    Ypredc.cm          <-cbind(dataC.sym$meta[, 1:3], predc.cm) 
    write.table(Ypredc.cm, "Ypredcb", dec=".", sep=";", row.names=FALSE)
    Ypredcb.sym        <- read.sym.table("Ypredcb", header=TRUE, sep=";",dec=".", row.names=NULL)  
    rcresb             <- CorCovSymbJenn(Ypredcb.sym)
    rcb                <- rcresb$corr[1, 2]
    Rc.cm[i,]	         <- rcb
    #METHODE 1 : METHODE DES CENTRES (VALIDATION --> RMSEV)
    val.regcm     <- sym.lm(Condemn  ~ ., dataV.sym, method ="cm")    # sym.var(data.sym, 4)    
    val.pred.cm   <- predictsym.lm(cal.regcm, dataV.sym, method="cm")
    RMSEv.m.cm    <- RMSE.L(sym.var(dataV.sym, 1), val.pred.cm$Fitted)
    RMSEv.M.cm    <- RMSE.U(sym.var(dataV.sym,1), val.pred.cm$Fitted) 
    RMSEv.cm[i, ] <- cbind(RMSEv.m.cm, RMSEv.M.cm)
    # Rv.cm
    colint             <- matrix("$I", dataV.sym$N, 1) 
    predv.cm           <-cbind(colint, val.pred.cm$Fitted)
    colnames(predv.cm) <- c("$I", "Pred.min", "Pred.max")
    Ypredv.cm          <-cbind(dataV.sym$meta[,1:3], predv.cm) 
    write.table(Ypredv.cm, "Ypredvb", dec=".", sep=";", row.names=FALSE)
    Ypredvb.sym        <- read.sym.table("Ypredvb", header=TRUE, sep=";",dec=".",row.names=NULL)  
    rvresb             <- CorCovSymbJenn(Ypredvb.sym)
    rvb                <- rvresb$cor[1,2]
    Rv.cm[i,]	         <- rvb	       
    #METHODE 2 : METHODE DES CENTRES ET DES RANGS  (CALIBRATION --> RMSEC)
    cal.regcrm     <- sym.lm(Condemn  ~ ., dataC.sym, method ="crm")    # sym.var(data.sym, 4)    
    cal.pred.crm   <- predictsym.lm(cal.regcrm, dataC.sym, method="crm")
    RMSEc.m.crm    <- RMSE.L(sym.var(dataC.sym, 1), cal.pred.crm$Fitted)
    RMSEc.M.crm    <- RMSE.U(sym.var(dataC.sym, 1), cal.pred.crm$Fitted) 
    RMSEc.crm[i, ] <- cbind(RMSEc.m.crm, RMSEc.M.crm)
    # Rc.crm
    colint              <- matrix("$I", dataC.sym$N, 1) 
    predc.crm           <- cbind(colint,cal.pred.crm$Fitted)
    colnames(predc.crm) <- c("$I","Pred.min","Pred.max")
    Ypredc.crm          <-cbind(dataC.sym$meta[,1:3],predc.crm) 
    write.table(Ypredc.crm, "Ypredct", dec=".", sep=";", row.names=FALSE)
    Ypredct.sym         <- read.sym.table("Ypredct", header=TRUE, sep=";",dec=".",row.names=NULL)  
    rcrest              <- CorCovSymbJenn(Ypredct.sym)
    rct                 <- rcrest$cor[1,2]
    Rc.crm[i,]	        <- rct	    
    #METHODE 2 : METHODE DES CENTRES ET DES RANGS (VALIDATION --> RMSEV)
    val.regcrm     <- sym.lm(Condemn  ~ ., dataV.sym, method ="crm")    # sym.var(data.sym, 4)    
    val.pred.crm   <- predictsym.lm(cal.regcrm, dataV.sym, method="crm")
    RMSEv.m.crm    <- RMSE.L(sym.var(dataV.sym, 1), val.pred.crm$Fitted)
    RMSEv.M.crm    <- RMSE.U(sym.var(dataV.sym, 1), val.pred.crm$Fitted) 
    RMSEv.crm[i, ] <- cbind(RMSEv.m.crm, RMSEv.M.crm)
    # Rv.crm
    colint              <- matrix("$I", dataV.sym$N, 1) 
    predv.crm           <- cbind(colint,val.pred.crm$Fitted)
    colnames(predv.crm) <- c("$I","Pred.min","Pred.max")
    Ypredv.crm          <- cbind(dataV.sym$meta[,1:3],predv.crm) 
    write.table(Ypredv.crm, "Ypredvt", dec=".", sep=";", row.names=FALSE)
    Ypredvt.sym         <- read.sym.table("Ypredvt", header=TRUE, sep=";",dec=".",row.names=NULL)  
    rvrest              <- CorCovSymbJenn(Ypredvt.sym)
    rvt                 <- rvrest$cor[1,2]
    Rv.crm[i, ]	        <- rvt 
    
    #METHODE 3 : MÉTHODE SCM (CALIBRATION --> RMSEC, validation --> RMSEv)
    reg            <- RegSymbvc(dataC.Y.sym, dataC.X.sym, dataV.Y.sym, dataV.X.sym)
    RMSEc.reg[i, ] <- reg$RMSEc
    RMSEv.reg[i, ] <- reg$RMSEv
    Rc.reg[i, ]	   <- reg$Rc 
    Rv.reg[i, ]	   <- reg$Rv  
  }  
  # GRAPHES DES RMSEC ET RMSEV
  maxC <- max(RMSEc.cm, RMSEc.crm, RMSEc.reg)
  maxV <- max(RMSEv.cm, RMSEv.crm, RMSEv.reg)  
  par(mfrow=c(2, 3))
  boxplot(RMSEc.cm, main="Méthode des centres (cal.)", ylab="RMSEc", ylim=c(0, maxC), 
          cex.axis=1.2, col="grey", boxwex=0.5)
  abline(h=seq(0, maxC, by=1), lty = "dotted")
  boxplot(RMSEc.crm, main="Méthode CRM (cal.)", ylab="RMSEc", ylim=c(0, maxC)
          , cex.axis=1.2, col="grey", boxwex=0.5)
  abline(h=seq(0, maxC, by=1), lty = "dotted")
  # boxplot(RMSEc.regbiv, main="Méthode bivariée (cal.)", ylab="RMSEc", ylim=c(0, maxC))
  # abline(h=seq(0, maxC, by=1), lty = "dotted")
  boxplot(RMSEc.reg, main="Méthode SCR (cal.)", ylab="RMSEc", ylim=c(0, maxC)
          , cex.axis=1.2, col="grey", boxwex=0.5)
  abline(h=seq(0, maxC, by=1), lty = "dotted")
  
  boxplot(RMSEv.cm, main="Méthode des centres (val.)", ylab="RMSEv", ylim=c(0, maxV), 
          cex.axis=1.2, col="grey", boxwex=0.5)
  abline(h=seq(0, maxV, by=1), lty = "dotted")
  boxplot(RMSEv.crm, main="Méthode CRM (val.)", ylab="RMSEv", ylim=c(0, maxV),
          cex.axis=1.2, col="grey", boxwex=0.5)
  abline(h=seq(0, maxV, by=1), lty = "dotted")
  # boxplot(RMSEv.regbiv, main="Méthode bivariée (val.)", ylab="RMSEv", ylim=c(0, maxV))
  # abline(h=seq(0, maxV, by=1), lty = "dotted")
  boxplot(RMSEv.reg, main="Méthode SCR (val.)", ylab="RMSEv", ylim=c(0, maxV),
          cex.axis=1.2, col="grey", boxwex=0.5)
  abline(h=seq(0, maxV, by=1), lty = "dotted")
  # GRAPHES DES CORRELATIONS Y-YPRED
  Rc           <- cbind(Rc.cm, Rc.crm, Rc.reg)
  colnames(Rc) <- c("Centres", "CRM", "SCR")  
  Rv           <- cbind(Rv.cm, Rv.crm, Rv.reg)
  colnames(Rv) <- c("Centres", "CRM", "SCR")
  par(mfrow=c(1, 2))
  boxplot(Rc, main="Résultats de calibration", ylab="Corrélation(Y obs.,Y prédit)", 
          ylim=c(-1, 1), col="grey", boxwex=0.5)
  abline(h=c(-1, -0.5, 0, 0.5, 1), lty = "dotted")
  
  boxplot(Rv, main="Résultats de validation", ylab="Corrélation(Y obs., Y prédit)", 
          ylim=c(-1, 1), col="grey", boxwex=0.5)
  abline(h=c(-1, -0.5, 0, 0.5, 1), lty = "dotted") 
  # SORTIE DES RÉSULTATS
  list(Rc.cm=Rc.cm, Rv.cm=Rv.cm, RMSEc.cm=RMSEc.cm, RMSEv.cm=RMSEv.cm,
       Rc.crm=Rc.crm, Rv.crm=Rv.crm, RMSEc.crm=RMSEc.crm, RMSEv.crm=RMSEv.crm,
       Rc.reg=Rc.reg, Rv.reg=Rv.reg, RMSEc.reg=RMSEc.reg, RMSEv.reg=RMSEv.reg)
}
